<script>
    import * as d3 from "d3";

    export let subplot;
    export let xScale;
    export let tickPadding = 4;
    export let tickSize = 6;

    // Where to plot the axis
    $: leftMargin = xScale.range()[0];
    $: left = leftMargin;
    $: bottom = subplot.computed.y + subplot.computed.h;
    $: top = subplot.computed.y;
    $: center =
        0.5 *
        (subplot.computed.yScale.range()[0] +
            subplot.computed.yScale.range()[1]);

    // Set the tick format
    let ytick_format;
    $: {
        if (subplot.ytick_format == "auto") {
            let ytick_step = 0.1; // Default that is not going to be used
            ytick_step = subplot.computed.ticks[1] - subplot.computed.ticks[0];
            ytick_step = isNaN(ytick_step) ? 1e-3 : ytick_step;
            ytick_format = d3.format("." + d3.precisionFixed(ytick_step) + "f");
        } else {
            ytick_format = subplot.ytick_format;
        }
    }
</script>

<g class="yaxis">
    <!-- Vertical axis line, spanning the full domain -->
    <line
        x1={left}
        x2={left}
        y1={bottom}
        y2={top}
        stroke="black"
        class="stroke-black dark:stroke-white"
        stroke-width="1.5" />

    <!-- Primary axis ticks -->
    {#if subplot.scale === "log10"}
        {#each subplot.computed.logTicks as logTick}
            {#if logTick.multiplier == 1}
                <line
                    x1={left - tickSize}
                    x2={left}
                    y1={subplot.computed.yScale(logTick.value)}
                    y2={subplot.computed.yScale(logTick.value)}
                    stroke="black"
                    class="stroke-black dark:stroke-white"
                    stroke-width="0.75" />
                {#if subplot.yaxis_annotation == "visible"}
                    <text
                        x={left - tickSize - tickPadding}
                        y={subplot.computed.yScale(logTick.value)}
                        font-family="-apple-system, 'Helvetica Neue', sans-serif"
                        font-size="12px"
                        fill="black"
                        class="fill-black dark:fill-white"
                        alignment-baseline="middle"
                        text-anchor="end"
                        >10<tspan baseline-shift="super" font-size="9px"
                            >{logTick.exponent}</tspan>
                    </text>
                {/if}
            {:else}
                <line
                    x1={left - 3}
                    x2={left}
                    y1={subplot.computed.yScale(logTick.value)}
                    y2={subplot.computed.yScale(logTick.value)}
                    stroke="black"
                    class="stroke-black dark:stroke-white"
                    stroke-width="0.75" />
            {/if}
        {/each}
    {:else if subplot.computed.customTicks}
        {#each subplot.computed.customTicks as tick}
            <line
                x1={left - tickSize}
                x2={left}
                y1={subplot.computed.yScale(tick.value)}
                y2={subplot.computed.yScale(tick.value)}
                stroke="black"
                class="stroke-black dark:stroke-white"
                stroke-width="0.75" />
            {#if subplot.yaxis_annotation == "visible"}
                <text
                    x={left - tickSize - tickPadding}
                    y={subplot.computed.yScale(tick.value)}
                    font-family="-apple-system, 'Helvetica Neue', sans-serif"
                    font-size="12px"
                    fill="black"
                    class="fill-black dark:fill-white"
                    dominant-baseline="central"
                    text-anchor="end">
                    {d3.format(ytick_format)(tick.annot)}
                </text>
            {/if}
        {/each}
    {:else}
        {#each subplot.computed.ticks as tick}
            <line
                x1={left - tickSize}
                x2={left}
                y1={subplot.computed.yScale(tick)}
                y2={subplot.computed.yScale(tick)}
                stroke="black"
                class="stroke-black dark:stroke-white"
                stroke-width="0.75" />
            {#if subplot.yaxis_annotation == "visible"}
                <text
                    x={left - tickSize - tickPadding}
                    y={subplot.computed.yScale(tick) + 4}
                    font-family="-apple-system, 'Helvetica Neue', sans-serif"
                    font-size="12"
                    fill="black"
                    class="fill-black dark:fill-white"
                    dominant-baseline="auto"
                    text-anchor="end">{d3.format(ytick_format)(tick)}</text>
            {/if}
        {/each}
    {/if}
    {#if subplot["y_label"]}
        <text
            transform="translate({left - 50}, {center}) rotate(-90)"
            x="0"
            y="0"
            font-family="-apple-system, 'Helvetica Neue', sans-serif"
            font-size="12px"
            font-weight="bold"
            fill="black"
            class="fill-black dark:fill-white"
            alignment-baseline="middle"
            text-anchor="middle">{subplot["y_label"]}</text>
    {/if}
</g>

<style>
    text {
        user-select: none;
    }
</style>
